在Debian中将PHP脚本作为守护进程运行

时间:2015-06-29 05:14:25

标签: php linux debian daemon init.d

我正在尝试在Debian中启动一个PHP脚本作为守护进程。我也希望它也能在启动时启动。

我一直在使用/path/to/php /path/to/script/Insert.php &而没有问题,也可以shell_exec("nohup /path/to/php /path/to/script/Insert.php >/dev/null &")。我尝试使用下面的脚本,但它不会使脚本进入运行状态。

将文件复制到/etc/init.d/并使用update-rc.d没有问题。我可以使用service congen-insert start来启动'脚本,但它似乎并没有真正运行,它也没有开始做任何工作。

我错过了什么,或者我在哪里弄错了脚本?

我知道有几种方法可以解决这个问题,但我真的只是想了解我做错了什么,或者为什么我做的不起作用。

非常感谢任何帮助或建议!如果您需要其他任何内容或我在描述中遗漏的任何内容,请告诉我,以便我能够更正。

提前致谢。

服务脚本

#! /bin/sh
### BEGIN INIT INFO
# Provides:          congen-insert
# Required-Start:    $local_fs $network
# Required-Stop:     $local_fs
# Default-Start:     2 3 4 5
# Default-Stop:      0 1 6
# Short-Description: congen-insert
# Description:       DB Insert Daemon
### END INIT INFO

NAME="congen-insert"
DESC=" DB Insert Daemon"
PIDFILE="/var/run/${NAME}.pid"
LOGFILE="/var/log/${NAME}.log"

DAEMON="/path/to/php"
DAEMON_OPTS="/path/to/script/Insert.php"

START_OPTS="--start --background --make-pidfile --pidfile ${PIDFILE} --exec ${DAEMON} ${DAEMON_OPTS}"
STOP_OPTS="--stop --pidfile ${PIDFILE}"

test -x $DAEMON || exit 0

set -e

case "$1" in
    start)
        echo -n "Starting ${DESC}: "
        start-stop-daemon $START_OPTS >> $LOGFILE
        echo "$NAME."
        ;;
    stop)
        echo -n "Stopping $DESC: "
        start-stop-daemon $STOP_OPTS
        echo "$NAME."
        rm -f $PIDFILE
        ;;
    restart|force-reload)
        echo -n "Restarting $DESC: "
        start-stop-daemon $STOP_OPTS
        sleep 1
        start-stop-daemon $START_OPTS >> $LOGFILE
        echo "$NAME."
        ;;
    status)
    echo -n "Sorry, this isn't implemented yet"
    ;;
    *)
        N=/etc/init.d/$NAME
        echo "Usage: $N {start|stop|restart|force-reload}" >&2
        exit 1
        ;;
esac

exit 0

正在尝试运行的脚本:

const LoaderPath = __DIR__ . DIRECTORY_SEPARATOR . ".." .DIRECTORY_SEPARATOR . "includes.php";

require_once  LoaderPath;

use PhpAmqpLib\Channel\AMQPChannel;
use PhpAmqpLib\Message\AMQPMessage;
use requests\InsertRequest;

$connection = GetRabbitConnection();

$channel = $connection->channel();

$RedisClient = GetRedisClient();

DeclareQueues($connection, $RedisClient);

$MySQLHost = $RedisClient->get(MySQLHostKey);
$MySQLUser = $RedisClient->get(MySQLUserKey);
$MySQLPassword = $RedisClient->get(MySQLPasswordKey);
$MySQLDatabase = $RedisClient->get(MySQLDatabaseKey);

$InsertExchange = $RedisClient->get(Insert.":".Exchange);
$InsertQueue = $RedisClient->get(Insert.":".Queue);
$Prefetch = $RedisClient->get(Insert.":".Prefetch);

$RedisClient->disconnect();
$RedisClient = null;

$mysql= new mysqli($MySQLHost, $MySQLUser, $MySQLPassword, $MySQLDatabase);

$channel->basic_qos(0,$Prefetch,false);

$channel->basic_consume($InsertQueue, $InsertExchange, false, false, false, false, "callback");


echo "Consuming on Exchange $InsertExchange with Queue $InsertQueue\n";

while(true) {
    $channel->wait();
}

$channel->close();

function callback(AMQPMessage $message){
    global $mysql;
    echo "Message received", "\n";
    $InsertRequest = new InsertRequest($message->body);

    echo "Running Insert Statement\n";
    if (!$mysql->query($InsertRequest->SQL)){
        echo "Error: ".$mysql->error;
    }

    /** @type AMQPChannel $channel */
    $channel = $message->delivery_info['channel'];
    $channel->basic_ack($message->delivery_info['delivery_tag']);
    echo "Insert Complete\n";

}

2 个答案:

答案 0 :(得分:1)

问题在于重定向输出。我还修改了带有bash标头的php文件,因此它不会显示为顶部的多个php进程,而是显示文件名:

修订后的服务脚本:

#! /bin/sh

### BEGIN INIT INFO
# Provides:          congen-insert
# Required-Start:    $local_fs $network
# Required-Stop:     $local_fs
# Default-Start:     2 3 4 5
# Default-Stop:      0 1 6
# Short-Description: congen-insert
# Description:       ConGen DB Insert Daemon
### END INIT INFO

NAME="congen-insert"
DESC="DB Insert Process for ConGen"
PIDFILE="/var/run/${NAME}.pid"
LOGFILE="/var/log/${NAME}.log"

DAEMON="/var/congen/php/controllers/congen-insert"
DAEMON_OPTS="> /dev/null 2>&1"

START_OPTS="--start --background --make-pidfile --pidfile ${PIDFILE} --exec ${DAEMON} ${DAEMON_OPTS}"
STOP_OPTS="--stop --pidfile ${PIDFILE}"

test -x $DAEMON || exit 0

set -e

case "$1" in
    start)
        echo -n "Starting ${DESC}: "
        start-stop-daemon $START_OPTS >> $LOGFILE
        echo "$NAME."
        ;;
    stop)
        echo -n "Stopping $DESC: "
        start-stop-daemon $STOP_OPTS
        echo "$NAME."
        rm -f $PIDFILE
        ;;
    restart|force-reload)
        echo -n "Restarting $DESC: "
        start-stop-daemon $STOP_OPTS
        sleep 1
        start-stop-daemon $START_OPTS >> $LOGFILE
        echo "$NAME."
        ;;
    status)
    echo -n "Sorry, this isn't implemented yet"
    ;;
    *)
        N=/etc/init.d/$NAME
        echo "Usage: $N {start|stop|restart|force-reload}" >&2
        exit 1
        ;;
esac

exit 0

修改PHP脚本以运行:

#!/php52/php-5.6.6/bin/php
<?php
    const LoaderPath = __DIR__ . DIRECTORY_SEPARATOR . ".." . DIRECTORY_SEPARATOR . "includes.php";

    require_once  LoaderPath;

    use PhpAmqpLib\Channel\AMQPChannel;
    use PhpAmqpLib\Message\AMQPMessage;
    use requests\InsertRequest;

    $connection = GetRabbitConnection();

    $channel = $connection->channel();

    $RedisClient = GetRedisClient();

    DeclareQueues($connection, $RedisClient);

    $InsertExchange = $RedisClient->get(Insert.":".Exchange);
    $InsertQueue = $RedisClient->get(Insert.":".Queue);
    $Prefetch = $RedisClient->get(Insert.":".Prefetch);

    $RedisClient->disconnect();
    $RedisClient = null;

    $mysql= ConnectionBuilder::GetMySQLi();

    $channel->basic_qos(0,$Prefetch,false);

    $channel->basic_consume($InsertQueue, $InsertExchange, false, false, false, false, "callback");


    echo "Consuming on Exchange $InsertExchange with Queue $InsertQueue\n";

    while(true) {
        $channel->wait();
    }

    $channel->close();

    function callback(AMQPMessage $message){
        global $mysql;
        echo "Message received", "\n";
        $InsertRequest = new InsertRequest($message->body);

        echo "Running Insert Statement\n";
        if (!$mysql->query($InsertRequest->SQL)){
            echo "Error: ".$mysql->error;
        }

        /** @type AMQPChannel $channel */
        $channel = $message->delivery_info['channel'];
        $channel->basic_ack($message->delivery_info['delivery_tag']);
        echo "Insert Complete\n";

    }

将文件添加到/etc/init.d/并使php脚本和服务脚本都可执行后,我可以使用service congen-insert start启动服务并使用其他命令,就像任何其他init.d服务一样

应该注意的是,我将控制台重定向到/dev/null,但您也可以通过用可写路径替换/dev/null来重定向到文件。

对来自another SO post2>&1引用的2的解释是stderr的流编号(错误消息),1代表 [sic] < / em> stdout流(标准的非错误输出流)。“因此,我基本上将stdout重定向到/dev/null并将stderr重定向到stdout

答案 1 :(得分:-1)

  1. 使用交互式shell命令编写脚本来执行php脚本,如php from terminal示例所示。这仅适用于PHP编译为包含--with-readline选项

  2. 的情况
  3. 设置一个cron任务(linux任务调度程序)来运行此脚本,如cron setup示例所示。